﻿using System;
using System.ComponentModel;
using System.Net;
using System.Windows.Forms;

namespace WinFormsDownloadFileSpeed
{
    public partial class Form1 : Form
    {
        private WebClient Client = new WebClient();

        private string url = "http://snapshot.opera.com/windows/1986_12.01-1491/Opera-Next-12.01-1491.i386.exe";

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Client.DownloadFileAsync(new Uri(url), "temp.file", DateTime.Now);
            button1.Enabled = false;
        }

        void Client_DownloadProgressChanged(object sender, DownloadProgressChangedEventArgs e)
        {
            DateTime startTime = (DateTime)e.UserState;

            double speed = (e.BytesReceived / 1024) / (DateTime.Now - startTime).TotalSeconds;

            progressBar1.Text = String.Format("Speed: {0:F3} KB/sec", speed);
            progressBar1.Value = e.ProgressPercentage;
        }

        void Client_DownloadFileCompleted(object sender, AsyncCompletedEventArgs e)
        {
            MessageBox.Show("Downloaded!");
            button1.Enabled = true;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Client.DownloadFileCompleted += new AsyncCompletedEventHandler(Client_DownloadFileCompleted);
            Client.DownloadProgressChanged += new DownloadProgressChangedEventHandler(Client_DownloadProgressChanged);
        }
    }
}
