﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace WinFormsDownloadFileSpeed
{
    class MyProgressBar : ProgressBar
    {
        public MyProgressBar()
            : base()
        {
            SetStyle(ControlStyles.UserPaint, true);
            SetStyle(ControlStyles.AllPaintingInWmPaint, true);
            SetStyle(ControlStyles.OptimizedDoubleBuffer, true);
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            Rectangle rect = ClientRectangle;
            Graphics g = e.Graphics;

            ProgressBarRenderer.DrawHorizontalBar(g, rect);

            rect.Inflate(-1, -1);

            if (Value > 0)
            {
                Rectangle clip = new Rectangle(rect.X, rect.Y, (int)((float)Value / Maximum * rect.Width), rect.Height);
                ProgressBarRenderer.DrawHorizontalChunks(g, clip);
            }

            SizeF size = g.MeasureString(Text, Font);
            var a = this.Font;
            g.DrawString(Text, Font, new SolidBrush(ForeColor), new PointF(Width / 2 - (size.Width / 2.0f), Height / 2 - (size.Height / 2.0f)));
        }
    }
}
